typedef unsigned char byte;
typedef unsigned short word;

#include "trx433.h"

void shiftout(byte data)
{
	byte mask;
	mask = 0x80;
	
	while (mask != 0) {
		if (data & mask) {
			sbi(PORT_TRX, PTRXDATA);
		}
		else {
			cbi(PORT_TRX, PTRXDATA);
		}

		sbi(PORT_TRX, PTRXCLOCK);
		loop_until_bit_is_set(PIN_TRX, PTRXACKN);
		cbi(PORT_TRX, PTRXCLOCK);
		loop_until_bit_is_clear(PIN_TRX, PTRXACKN);
			
		mask = mask >> 1;
	}
}

byte shiftin(void)
{
	byte data;
	byte mask;
  
	mask=0x80;
	data=0;
	while (mask != 0) {
		loop_until_bit_is_set(PIN_TRX, PTRXCLOCK);
		
		if bit_is_set(PIN_TRX, PTRXDATA) {
			data=data | mask;
		}
		
		sbi(PORT_TRX, PTRXACKN);
		loop_until_bit_is_clear(PIN_TRX, PTRXCLOCK);
		cbi(PORT_TRX, PTRXACKN);
		
		mask = mask >> 1;
	}
	return(data);
}


void trx_send(void)
{
	sbi(DDR_TRX, PTRXCLOCK); //Clock->output
	cbi(DDR_TRX, PTRXACKN); //Ackn->input
	cbi(PORT_TRX, PTRXACKN); //pull-up aus
	
	sbi(PORT_TRX, PTRXCLOCK); //Clock->Hi
	loop_until_bit_is_set(PIN_TRX, PTRXACKN);
	cbi(PORT_TRX, PTRXCLOCK);
	loop_until_bit_is_clear(PIN_TRX, PTRXACKN);
	
	sbi(DDR_TRX, PTRXDATA); //Data->output
	
	shiftout(trxadr);
	
	if (trxadr == 0) {
		shiftout(trxdata0);
		shiftout(trxdata1);
		shiftout(trxdata2);
	}
	else
	{
		shiftout(trxdata0);
		shiftout(trxdata1);
		shiftout(trxdata2);
		shiftout(trxdata3);
		shiftout(trxdata4);
		shiftout(trxdata5);
		shiftout(trxdata6);
	}
	
	cbi(DDR_TRX, PTRXCLOCK); //clock->input
	cbi(DDR_TRX, PTRXDATA); //data->input
	cbi(PORT_TRX, PTRXDATA); //data->no pullup !
}

void trx_rcv(void)
{
	loop_until_bit_is_set(PIN_TRX, PTRXCLOCK);
		
	sbi(DDR_TRX, PTRXACKN); //ack->output
	sbi(PORT_TRX, PTRXACKN); //ack->high
	
	loop_until_bit_is_clear(PIN_TRX, PTRXCLOCK);
		
	cbi(PORT_TRX, PTRXACKN); //ack->low
	
	//loop_until_bit_is_clear(PIN_TRX, PTRXCLOCK);
	
	cbi(DDR_TRX, PTRXDATA); //data->input
	cbi(PORT_TRX, PTRXDATA);
	
	trxadr=shiftin();
	trxdata0=shiftin();
	trxdata1=shiftin();
	trxdata2=shiftin();
	
	if (trxadr != 0) {
		trxdata3=shiftin();
		trxdata4=shiftin();
		trxdata5=shiftin();
		trxdata6=shiftin();
	}
		
	cbi(DDR_TRX, PTRXACKN);//ack->input
	cbi(PORT_TRX, PTRXACKN);
}